define(['jquery', 'lib/js/config', 'knockout', 'json!config-package.json', 'api/shim'], function($, config, ko, cfgPkg, shim) {

    var firstLoad = true;
    var active_watcher = ko.computed(function() {
        var isActive = config.one.newtab.hasOwnProperty('user_idle_time') && config.one.newtab.user_idle_time.active() && config.one.newtab.user_idle_time.defaults.visible();
        var wpActive = config.one.newtab.wallpapers.defaults.hasOwnProperty('visible') && config.one.newtab.wallpapers.defaults.visible();

        isActive = isActive; // && wpActive;

        $('body').toggleClass('useridle-enabled', isActive);
        if (isActive) {
            initIde();
        } else {
            resetIdle();
        }
        return isActive;
    });

    var IDLE_TIMEOUT = 0,
        _idleSecondsCounter = 0,
        searchBarHasFocus,
        lastAction = 1,
        running = false,
        timer,
        settingsPanelOpened = false,
        openedTab,
        idleInterval,
        sWord = null;


    function CheckIdleTime() {
        if (!active_watcher()) {
            return;
        }

        if (lastAction) {
            _idleSecondsCounter++;
        }

        if (_idleSecondsCounter >= timer) {
            // console.log('Time expired!');
            if (lastAction) {
                showHide(0);
            }
        }
    }

    function getItems() {
        var objectsCollection = [$('#box-footer li.btnsWrapper')];

        // module sticky-video
        if ($('#sticky-video').length && !$('body').hasClass('show-hub')) {
            objectsCollection.push($('#sticky-video'));
        }

        // tabs
        $('#box-slider ul.slider-nav li').each(function(index) {
            objectsCollection.push($(this));
        });

        // module clock
        if (config.one.newtab.clock.active() && config.one.newtab.clock.settings.visible()) {
            objectsCollection.push($('#module-clock'));
        }

        //Module social-fb-like
        if ($('#module-socialfblike').length) {
            objectsCollection.push($('#module-socialfblike'));
        }

        // module search
        if (status || !sWord) {
            objectsCollection.push($('#module-search'));
        }

        // module logo (MYSTNT-672)
        if (config.one.newtab.hasOwnProperty('user_idle_time') && config.one.newtab.user_idle_time.hasOwnProperty('include_logo') && config.one.newtab.user_idle_time.include_logo()) {
            objectsCollection.push($('#module-logo'));
        }

        // module login
        if ($('#module-account-area').length) {
            objectsCollection.push($('#module-account-area'));
        }

        // module weather
        if (config.one.newtab.weather && config.one.newtab.weather.active() && config.one.newtab.weather.settings.visible()) {
            objectsCollection.push($('#module-weather'));
        }

        // addthis
        if ($('.addthis-smartlayers').length) {
            objectsCollection.push($('.addthis-smartlayers'));
        }

        // launcher
        if ($('#btn-launcher').length) {
            objectsCollection.push($('#btn-launcher'));
        }

        if ($('#countdown_widget').length) {
            objectsCollection.push($('#countdown_widget'));
        }

        // Games
        if ($('#module-games').length) {
            objectsCollection.push($('#module-games'));
        }

        // Launcher
        if ($('#module-launcher').length) {
            objectsCollection.push($('#module-launcher'));
        }

        //ToDo list
        if (config.one.newtab.todo_list && config.one.newtab.todo_list.active() && config.one.newtab.todo_list.settings.visible()) {
            // only if todo list have no notes
            if (!$('#module-todolist .contentbox .boxlist li').length) {
                objectsCollection.push($('#module-todolist.opening'));
            }
        }

        //notePad widget
        if (config.one.newtab.note_pad && config.one.newtab.note_pad.active() && config.one.newtab.note_pad.settings.visible()) {
            objectsCollection.push($('#btn-notepad'));
            // only if todo list have no notes
            if ($('#module-notepad').length) {
                objectsCollection.push($('#module-notepad.opening'));
            }
        }

        // Sign-in
        if (config.one.newtab.signin && config.one.newtab.signin.active()) {
            objectsCollection.push($('#module-signin'));
        }

        // Blog
        if (config.one.newtab.blog && config.one.newtab.blog.active()) {
            if ($('#btn-blog').length)
                objectsCollection.push($('#btn-blog'));
        }

        // Welcome message
        if (config.one.newtab.welcome) {
            objectsCollection.push($('#welcome-greeting-message'));
        }

        // Rating
        if ($('#btn-rate').length) {
            objectsCollection.push($('#btn-rate'));
        }

        // Criteo ads
        if ($('#criteo_ads').length) {
            objectsCollection.push($('#criteo_ads'));
        }

        // bottom related-searches
        if ($('#related-searches').length) {
            objectsCollection.push($('#related-searches'));
        }

        // bottom settings navigation menus
        if ($('#slider-nav').length) {
            objectsCollection.push($('#slider-nav'));
        }

        // module Social live feed
        if ($('body.social-feed-box-opening #social-feed-box').length) {
            objectsCollection.push($('body.social-feed-box-opening #social-feed-box'));
            if ($('#btn-socialfeeds').length)
                objectsCollection.push($('#btn-socialfeeds'));
        } else {
            if ($('#btn-socialfeeds').length) {
                objectsCollection.push($('#btn-socialfeeds'));
            }
            if ($('#social-feed-box-btns').length) {
                objectsCollection.push($('#social-feed-box-btns'));
            }
        }

        // module pull_down
        if (config.one.newtab.pull_down && config.one.newtab.pull_down.active() && config.one.newtab.pull_down.settings.visible()) {
            objectsCollection.push($('#module-pull-down'));
            objectsCollection.push($('#module-pull-down-arrow'));
        }

        return objectsCollection;
    }

    function showHide(status) {
        var objectsCollection = getItems(),
            sWord = $('#module-search input').val().trim();

        if(lastAction === status || running) {
            _idleSecondsCounter = 0;
            return;
        }

        // if hub panel opened
        if ($('body').hasClass('show-hub') && !status) {
            _idleSecondsCounter = 0;
            return;
        }

        // if search auto-suggestions panel is opened
        if ($('body').hasClass('show-search-suggestions') && !status) {
            _idleSecondsCounter = 0;
            return;
        }

        // if wallpapers panel opened
        if ($('body').hasClass('show-wallpapers-picker') && !status) {
            _idleSecondsCounter = 0;
            return;
        }

        // if weather panel opened
        if ($('body').hasClass('weather-panel-opened') && !status) {
            _idleSecondsCounter = 0;
            return;
        }

        // if settings panel opened
        if ($('body').hasClass('slider-open') && !status) {
            _idleSecondsCounter = 0;
            return;
        }

        // if slider is opened
        if ($('#ms-slider').length && ($('#ms-slider').hasClass('sp-full-screen') || $('body').hasClass('slider-pro-opened'))) {
            _idleSecondsCounter = 0;
            return;
        }

        // if shortcuts is current mouse-over
        if ($('body').hasClass('shortcuts-mouseover') && !status) {
            _idleSecondsCounter = 0;
            return;
        }

        // if notePad is current mouse-over
        if ($('body').hasClass('notepad-mouseover') && !status) {
            _idleSecondsCounter = 0;
            return;
        }

        //if notePad widget has focus
        if (config.one.newtab.note_pad && config.one.newtab.note_pad.active() && config.one.newtab.note_pad.settings.visible()) {
            if ($('#module-notepad').length && $('#module-notepad textarea.notebook').is(':focus') && !status) {
                _idleSecondsCounter = 0;
                return;
            }
        }

        // if games is current mouse-over
        if (($('body').hasClass('games-mouseover') || $('body').hasClass('playing-game')) && !status) {
            _idleSecondsCounter = 0;
            return;
        }

        // if launcher is current mouse-over
        if (($('body').hasClass('launcher-mouseover')) && !status) {
            _idleSecondsCounter = 0;
            return;
        }

        // if pull-down is current mouse-over
        if (($('body').hasClass('more-themes-mouseover')) && !status) {
            _idleSecondsCounter = 0;
            return;
        }

        if (!status) {
            searchBarHasFocus = !$('#module-search').hasClass('search-style-' + cfgPkg.newtab.search.defaults.style + '-focus-out');
            if (searchBarHasFocus && !sWord) {
                $('#module-search').addClass('search-style-' + cfgPkg.newtab.search.defaults.style + '-focus-out');
            }
        }

        if ($('body').hasClass('greeting-visible') && !status) {
            $('body').removeClass('greeting-visible');
        }

        lastAction = status;
        running = true;
        _idleSecondsCounter = 0;

        $('body').toggleClass('useridle-active', !status);

        $('.layer-content').toggleClass('tranparentBg', !status);

        $.each(objectsCollection, function(index, object) {
            // Bypass any element that has an show/hide override.
            if(object.hasClass('activity-exempt')) {
                return true;    //JQuery loop() continue; alternative.
            }

            // if settings panel opened, close it
            if (status) {
                object.removeClass('noactivity').addClass('activity');
            } else {
                object.removeClass('activity').addClass('noactivity');
                $('body').removeClass('hide-wallpapers-picker-info');
                $('body').addClass('useridle-tiggered-at-least-once');
            }

            if (object.closest('#box-slider ul.slider-nav').length && object.hasClass('selected')) {
                object.trigger('click');
                if (!status) {
                    openedTab = object;
                }
            }
        });

        if (status && openedTab) {
            openedTab.trigger('click');
            openedTab = null;
        }

        if (status && searchBarHasFocus) {
            $('#module-search').removeClass('search-style-' + cfgPkg.newtab.search.defaults.style + '-focus-out');
        }

        running =  false;
    }

    function initIde() {

        setTimeout(function() {
            if (config.one.newtab.hasOwnProperty('user_idle_time')) {
                IDLE_TIMEOUT = config.one.newtab.user_idle_time.defaults.timeout();
            }

            if (!IDLE_TIMEOUT) {
                return;
            }

            $('.layer-content').addClass('activity');

            timer = IDLE_TIMEOUT;
            idleInterval = setInterval(CheckIdleTime, 1000);
        }, firstLoad ? 3000 : 0);
        firstLoad = false;
    }

    function resetIdle() {
        $('.layer-content').removeClass('activity');
        clearTimeout(idleInterval);
    }

    $(document).ready(function() {

        //***
        //Silly fix for MYSTNT-834 : Logo Disco Flash
        $('body').addClass('useridle-active');
        $('body').removeClass('useridle-active');
        //***

        $('body').click(function() {
            resetTimer();
        });

        $('body').mousemove(function(e) {
            resetTimer();
        });

        $('body').on('keydown', function(e) {
            resetTimer();
        });

        // reset timer on all Ps object scrolling
        window.setTimeout(function() {
            $('.ps-container').on('scroll', function () {
                resetTimer();
            });
        }, 1000);

        if (document.addEventListener) {
            document.addEventListener("mousewheel", wMouseWheelHandler, false);
            document.addEventListener("DOMMouseScroll", wMouseWheelHandler, false);
        }
        else document.attachEvent("onmousewheel", wMouseWheelHandler);
    });

    function resetTimer() {
        if (!active_watcher()) {
            return;
        }
        _idleSecondsCounter = 0;
        if (!lastAction) {
            lastAction = 0;
            showHide(1);
        }
    }

    function wMouseWheelHandler(event) {
        resetTimer();
    }


    return {
        getItems: getItems
    };

});
